#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "serial.h"
#include "tlc5947.h"
#include "spi.h"

#define	NB_DRIVERS	1
#define	LIGHT_LEVEL 1000



/*
 Avec 1 bit de poids fort et 8 bit de poids faible
 
 666 
5   1
5   1
 777 
4   2
4   2
 333     8
 
*/


int groupes[NB_DRIVERS*DLED_CHANNELS];

//Dcompose un octet dans un tableau
void octetToDisplay(unsigned char msg, int *display[8])
{
    unsigned char octet=msg;
    int i;
    for(i=0; i<8;i++)
    {
        *(display[7-i])=(octet%2)*LIGHT_LEVEL;
        octet=octet/2;
    }
}



int main(void)
{

printf("Init. drivers\n");
init_LED_Drivers(NB_DRIVERS);

/* Les pattes des 7 segments sont connectes dans un ordre diffrent,
à l'aide de pointeurs on redfinie l'ordre de chaque afficheur 
dans l'ordre standart dcrit plus haut*/

//Remise en odre afficheur 1
int display1[8]; int *pt_disp1[8];
pt_disp1[0]=&display1[6];
pt_disp1[1]=&display1[5];
pt_disp1[2]=&display1[3];
pt_disp1[3]=&display1[2];
pt_disp1[4]=&display1[1];
pt_disp1[5]=&display1[7];
pt_disp1[6]=&display1[0];
pt_disp1[7]=&display1[4];

//Remise en odre afficheur 2
int display2[8]; int *pt_disp2[8];
pt_disp2[0]=&display2[5];
pt_disp2[1]=&display2[6];
pt_disp2[2]=&display2[0];
pt_disp2[3]=&display2[1];
pt_disp2[4]=&display2[2];
pt_disp2[5]=&display2[4];
pt_disp2[6]=&display2[3];
pt_disp2[7]=&display2[7];

//Remise en odre afficheur 3
int display3[8]; int *pt_disp3[8];
pt_disp3[0]=&display3[6];
pt_disp3[1]=&display3[5];
pt_disp3[2]=&display3[0];
pt_disp3[3]=&display3[1];
pt_disp3[4]=&display3[2];
pt_disp3[5]=&display3[7];
pt_disp3[6]=&display3[3];
pt_disp3[7]=&display3[4];


unsigned char octet1=0;
unsigned char octet2=0;
unsigned char octet3=0;


init_spi();

while(1)
{
    //octet1=0b11111111; // utile en test
    //octet2=0b11111111;
    //octet3=0b11111111;
    octet1=spi_exch(octet3);
    octet2=spi_exch(octet1);
    octet3=spi_exch(octet2);
    octetToDisplay(octet1,pt_disp1);
    octetToDisplay(octet2,pt_disp2);
    octetToDisplay(octet3,pt_disp3);
    int i;
	
	//concatnation des 3 tableaux en un seul pour utiliser set_LED_Drivers
    for (i=0;i<8;i++)
    {
        groupes[i]=display1[i];
        groupes[i+8]=display2[i];
        groupes[i+16]=display3[i];
    }
    set_LED_Drivers(groupes,NB_DRIVERS);

}

return 0;
}
